<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div class="search">
    <el-row>
      <el-form
        :model="formData"
        ref="formData"
        label-width="120px"
      >
        <el-col
          :span="5"
          v-if="nameItem"
        >
          <el-form-item
            :label="$t('env.name')"
            prop="name"
          >
            <el-input
              id="name"
              v-model="formData.name"
            />
          </el-form-item>
        </el-col>
        <el-col
          :span="5"
          v-if="ipItem"
        >
          <el-form-item
            :label="$t('env.ipAddress')"
            prop="ipAddress"
          >
            <el-input
              id="ipAddress"
              v-model="formData.ipAddress"
            />
          </el-form-item>
        </el-col>
        <el-col
          :span="5"
          v-if="labItem"
        >
          <el-form-item
            :label="$t('env.lab')"
            prop="lab"
          >
            <el-select
              id="lab"
              v-model="formData.lab"
            >
              <el-option
                v-for="item in labOptions"
                :label="item"
                :value="item"
                :key="item"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col
          :span="5"
          v-if="statusItem"
        >
          <el-form-item
            :label="$t('env.status')"
            prop="status"
          >
            <el-select
              id="type"
              v-model="formData.status"
            >
              <el-option
                v-for="item in statusOptions"
                :label="item"
                :value="item"
                :key="item"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col
          :span="5"
          v-if="typeItem"
        >
          <el-form-item
            :label="$t('env.type')"
            prop="formData.status"
          >
            <el-select
              id="type"
              v-model="type"
            >
              <el-option
                v-for="item in typeOption"
                :label="item"
                :value="item"
                :key="item"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col
          :span="4"
          v-if="applicantItem"
        >
          <el-form-item
            :label="$t('env.applicant')"
            prop="requestedBy"
          >
            <el-input
              id="applicant"
              v-model="formData.requestedBy"
            />
          </el-form-item>
        </el-col>
        <el-col :span="5">
          <el-form-item>
            <el-button
              id="searchBtn"
              type="primary"
              @click="search"
            >
              {{ $t('common.search') }}
            </el-button>
            <el-button
              id="resetBtn"
              @click="resetForm('formData')"
            >
              {{ $t('common.reset') }}
            </el-button>
          </el-form-item>
        </el-col>
        <div class="clearfix" />
      </el-form>
    </el-row>
  </div>
</template>

<script>
import axios from 'axios'
import { BASE_URL } from '../tools/constant.js'
export default {
  props: {
    nameItem: {
      type: Boolean,
      default: true
    },
    ipItem: {
      type: Boolean,
      default: false
    },
    labItem: {
      type: Boolean,
      default: false
    },
    statusItem: {
      type: Boolean,
      default: false
    },
    typeItem: {
      type: Boolean,
      default: false
    },
    applicantItem: {
      type: Boolean,
      default: false
    },
    statusOptions: {
      type: Array,
      default () {
        return [
          'ALL',
          'Waiting',
          'Rejected',
          'Approved'
        ]
      }
    }
  },
  data () {
    return {
      formData: {
        name: '',
        ipAddress: '',
        lab: 'ALL',
        status: 'ALL',
        requestedBy: '',
        type: 'ALL'
      },
      typeOption: ['ALL', 'PowerGrid', 'VR/AR', 'IoV', 'Enterprise'],
      labOptions: []
    }
  },
  methods: {
    search () {
      let formD = {}
      if (this.nameItem) {
        formD['name'] = this.formData.name
      }
      if (this.ipItem) {
        let regexIP = /^((25[0-5]|(2[0-4]|1[0-9]|[1-9]|)[0-9])(\.(?!$)|$)){4}$/
        if (!this.formData.ipAddress.match(regexIP)) {
          this.$parent.$parent.$parent.$parent.errorMessage(this.$t('tip.invalidIP'))
          return
        }
        formD['ipAddress'] = this.formData.ipAddress
      }
      if (this.labItem) {
        formD['lab'] = this.formData.lab
      }
      if (this.statusItem) {
        formD['status'] = this.formData.status
      }
      if (this.applicantItem) {
        formD['requestedBy'] = this.formData.requestedBy
      }
      if (this.typeItem) {
        formD['type'] = this.formData.type
      }
      this.$emit('getSearchData', formD)
    },
    resetForm (formName) {
      this.$refs[formName].resetFields()
      this.$emit('getSearchData', this.formData)
    },
    async getLabs (data) {
      this.labOptions = []
      let url = BASE_URL + '/getLab'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.labOptions.push('ALL')
        for (var i = 0; i < res.data.length; i++) {
          this.labOptions.push(res.data[i].labName)
        }
      }, error => {
        if (error) {
          this.$parent.$parent.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    }
  },
  beforeMount () {
    this.getLabs()
  }
}
</script>
<style lang='less' scoped>
.search{
  .el-select{
    width:100%;
  }
}
</style>
